#include <stdio.h>
#include <string.h>

const long MAX_BOXES = 25; //20
const long MAX_PILES = 55; //50
const long BOX_SALE_PRICE = 10; //10!

template<class T>inline T Max(T a, T b){return a > b ? a : b;}

struct Pile
{
	long cBoxes;
	long costs[MAX_BOXES];
	long cAmounts;
	long amounts[MAX_BOXES + 1];

	Pile(void) : cBoxes(0), cAmounts(0) {}
	void Read(void)
	{
		scanf("%ld", &cBoxes);
		for(long iBox = 0; iBox < cBoxes; ++iBox)
			scanf("%ld", &costs[iBox]);
	}

	long CalcMaxProfit(void)const
	{
		long maxProfit = 0, curProfit = 0;
		for(long iBox = 0; iBox < cBoxes; ++iBox)
		{
			curProfit += (BOX_SALE_PRICE - costs[iBox]);
			maxProfit = Max(curProfit, maxProfit);
		}
		return maxProfit;
	}

	void CalcAmountsToBuy(long profit)
	{
		cAmounts = 0;
		if(! profit)amounts[cAmounts++] = 0;
		long curProfit = 0;
		for(long iBox = 0; iBox < cBoxes; ++iBox)
		{
			curProfit += (BOX_SALE_PRICE - costs[iBox]);
			if(curProfit == profit)
				amounts[cAmounts++] = iBox + 1;
		}
	}
};

template<unsigned long TMaxSum>
struct GroupSummator
{
	int isSumExists[TMaxSum + 1];

	GroupSummator(void)
	{
		memset(isSumExists, 0, sizeof(isSumExists));
		isSumExists[0] = 1;
	}

	void Reset(void)
	{
		memset(isSumExists, 0, sizeof(isSumExists));
		isSumExists[0] = 1;
	}

	void AddGroup(long *pSummands, long cSummands)
	{
		int isSumExistsNew[TMaxSum + 1];
		memset(isSumExistsNew, 0, sizeof(isSumExistsNew));
		for(long num = 0; num <= TMaxSum; ++num)
			if(isSumExists[num])
			{
				for(long iSummand = 0; iSummand < cSummands; ++iSummand)
				{
					if(num + pSummands[iSummand] <= TMaxSum)
						isSumExistsNew[num + pSummands[iSummand]] = 1;
				}
			}
		memcpy(isSumExists, isSumExistsNew, sizeof(isSumExists));
	}

	void WriteFirst(long maxAmountToWrite)const
	{
		long cWritten = 0;
		for(long num = 0; num <= TMaxSum; ++num)
			if(isSumExists[num])
			{
				if(cWritten)putchar(' ');
				printf("%ld", num);
				++cWritten;
				if(cWritten >= maxAmountToWrite)break;
			}
		putchar('\n');
	}
};

Pile pile;
GroupSummator<(MAX_BOXES + 1) * MAX_PILES> summator;

int main(void)
{
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	long cPiles, iPile, iTest = 0;

	for(;;)
	{
		scanf("%ld", &cPiles);
		if(! cPiles)break;
		if(iTest++)putchar('\n');
		long profit = 0, curProfit;
		summator.Reset();
		for(iPile = 0; iPile < cPiles; ++iPile)
		{
			pile.Read();
			curProfit = pile.CalcMaxProfit();
			profit += curProfit;
			pile.CalcAmountsToBuy(curProfit);
			summator.AddGroup(pile.amounts, pile.cAmounts);
		}
		printf("Workyards %ld\n", iTest);
		printf("Maximum profit is %ld.\n", profit);
		printf("Number of pruls to buy: ");
		summator.WriteFirst(10);
	}

#ifndef ONLINE_JUDGE
	fclose(stdout);
	fclose(stdin);
#endif

	return 0;
}